/**
 * @file
 * Callback for jqueryUiTimepicker.
 */

(function ($) {
  // Fix conflicts.
  $.fn.uiTimepicker = $.fn.timepicker;
  delete $.fn.timepicker;

  Drupal.behaviors.jqueryUiTimepicker = {
    attach:(context, settings) => {
      once('init-jquery-ui-timepicker', '.jquery-ui-timepicker-widget', context).forEach((el) => {
        const custom = settings.timepicker.jquery_ui_timepicker[el.getAttribute('field-name')];

        const input = $(el).find('input[type="time"]');
        if (input.length === 0) {
          return;
        }

        // Build options object.
        const requiredOptions = {};
        const options = Object.assign(custom, {});

        input.uiTimepicker(options);
      });
    }
  };

}(jQuery));
